Description

If a parameter is referenced by another parameter, then renaming the former is not always reflected in the latter. The seems to
happen when the latter is a string parameter.

To reproduce:

. add a String Parameter to the canvas

. rename to x

. add a String Replace actor to the canvas

. double-click on String Replace, set pattern to $x, close dialog
.rename xtoy

. double-click on String Replace, pattern is set to y instead of $y
History

#1 - 10/12/2012 12:56 PM - Christopher Brooks

That's a strange bug.
| think the problem is with the $x syntax in the pattern PortParameter that is in string mode.

ptolemy/actor/gui/RenameConfigurer.java generates a MoMLChangeRequest
that looks like:
<property name="x"><rename name="y"/></property>

MoMLParser parses it and calls ptolemy.data.expr.Variable.setName() which
finds the listeners and sets the expression in an unusual manner:

--start--

if (_valueListeners != null) {

Iterator listeners = _valueListeners.iterator();

while (listeners.hasNext()) {

ValuelListener listener = (ValueListener) listeners

.next();

if (listener instanceof Variable) {

// The listener could be referencing this variable.
ParseTreeFreeVariableRenamer renamer = new ParseTreeFreeVariableRenamer();
((Variable) listener)._parselfNecessary();

renamer.renameVariables(

((Variable) listener)._parseTree,

(Variable) listener, this, name);

ParseTreeWriter writer = new ParseTreeWriter();

((Variable) listener)

.setExpression(writer

.parseTreeToExpression(((Variable) listener)._parseTree));
changed.add(listener);

}

}

1

super.setName(name);

/I With the new name, we may now shadow variables that

/I were not previously shadowed. Invalidate those. _invalidateShadowedSettables(getContainer());
validate();

--end---

| think the problem is that the $x expression is getting evaluated somewhere.

#2 - 12/03/2012 01:45 PM - Daniel Crawl

04/10/2024 1/2




| added some test cases for this to $PTIl/ptolemy/data/expr/test/Parameter.tcl.

#3 - 03/27/2013 02:31 PM - Redmine Admin
Original Bugzilla ID was 5723

#4 - 06/28/2013 10:44 AM - Daniel Crawl

- Status changed from New to Resolved

Fixed. | also added another test to Rename.tcl.
